package Zaphod::Editor::Undo;
use strict;
use Attribute::Handlers;
use Zaphod::Editor::Action;
use Data::Dumper;

use vars qw($VERSION);
$VERSION = '0.02';

=head2 TODO

Refactor this into a simple/stupid collector that
collects every action as the result.

=cut

sub Action : ATTR(CODE) {
    my ($package, $symbol, $referent, $attr, $data) = @_;

    #print STDERR
    #    ref($referent), " ",
    #    *{$symbol}{NAME}, " ",
    #    "($referent) ", "was just declared ",
    #    "and ascribed the ${attr} attribute ",
    #    "with data ($data)\n",

    my $name = *{$symbol}{NAME};
    #my $undo = \%{ "$package\::undo" };
    # Install our wrapper to record the undo information
    no strict 'refs';
    no warnings 'redefine';
    #warn "Installing " . *{$symbol}{NAME};
    *{$symbol} = sub {
        #warn "$name was called.";
        my $self = shift;

        # Is it smart to do the "inverse" lookup at runtime?
        # my $verb = ${"$package\::undo"}{$name};
        # if (! defined $verb) {
        #     $verb = { reverse %{"$package\::undo"} }->{$name};
        # };
        #warn "Don't know how to reverse '$name'. No undo recorded."
        #    unless $verb;

        my $action = $referent->($self,@_);

        if (ref $action eq 'ARRAY') {
            $action = Zaphod::Editor::Action->new(@$action);
        };

        $action->perform($self);
        $self->record_undo($action);
    };
};

1;

=head1 AUTHOR

Written by Max Maischein E<lt>corion@cpan.orgE<gt>

Copyright Max Maischein 2005,2006; All Rights Reserved.

This program is free software; you can redistribute it
and/or modify it under the same terms as Perl itself.

=head1 SEE ALSO

L<Zaphod>

=cut
